#include <stdio.h>
#include <stdlib.h>  
#include <math.h>  
#include <malloc.h> 
#include <time.h>

int Bias_Correction;



#include "qsort.c"
#include "bds_prod_integral_comp.c"
#include "bds_g.c"
#include "bds_stat_lebaron.c"
#include "series_h&w05.c"
#include "rang.c"

main()
{  
	//     void laws(double *x, int n, int loi, double theta);
	//     void matM(int n, double *NN, double **MM);
	//     void puiss(int p, double *c);
	//     void bds_rank(int *rangs, int n, int p, double *stat, double **MM, double *NN, double *c);
	//     void rank(double *x, int n, int *R);
	
	FILE *fp1, *fp2;
	double **MM, *NN,  **MM2, *NN2;
	double var[20], *x, cte[20], cte2[20], eps;
	double param, temp2, rej_cvm[9][7]; 
	double seuil[9][7], seuil2[6][20], seuil3[6][20], stat[20];
	int n, k, i, r, p, serie[6], l, m, *rangs; 
	long int it, j;
	long int reject[9][7];
	static char *nom_loi[17] = { " I.I.D.", "AR(1)", "ARCH(1)",
		"Threshold GARCH(1,1)", "Bilinear AR(1)",  "Nonlinear MA(1)", "Threshold AR(1)", 
		"Fractional AR(1)", "Sign AR(1)", };
	long int *ii;
	unsigned long int i0, j00, k0;
	time_t *tloc;
	char *fichier[16];
	
	/********** Fixation du seed **********/
	ii = (long int *)malloc(sizeof(long int));  
	tloc=(time_t*)malloc(sizeof(time_t));  
	*ii=time(tloc);  
	j00=*ii*rand()*123;  
	k0=*ii*rand()*756;  
	i0=*ii*rand()*6675;  
	kisset(i0,j00,k0);   
	
	/****  Allocation de la mmoire  ****/
	
	
	
	
	
	/**** Paramtres de la simulation ****/ 
	/****   (  changer au besoin )   ****/
	
	
	serie[0] = 20;   /*** Longueurs ***/ 
	serie[1] = 50;   /***   des    ***/
	serie[2] = 100;  /***  sries  ***/
	serie[3] = 200;
	serie[4] = 500;
	serie[5] = 1000;
	
	
	
	it = 10000;    /*** Nombre d'itrations ***/
	
	p =6;
	
	
	fichier[0] = "ResH/powc-20.dat";        /****************/
	fichier[1] = "ResH/powc-50.dat";        /**  Noms des  **/
	fichier[2] = "ResH/powc-100.dat";       /**  fichiers  **/
	fichier[3] = "ResH/powc-200.dat";       /**   sortie   **/
	fichier[4] = "ResH/powc-500.dat";       /****************/
	fichier[5] = "ResH/powc-1000.dat";
	
	l = 2;
	n = serie[l];
	printf("\n  n=%d ", n);
	/* Lecture des seuils  
	The file "seuil.txt" contains the critical values for m=2,3,..6 for each 
	of the following statistics as defined in Genest et al. JASA paper 2006. 
	Row 0: BDS,$S_n$
    Row 1: $\tilde S_n^*$,
    Row 2: $\tilde I_n^*$,
    Row 3: $\tilde M_n^*$,
    Row 4: $\tilde T_n^*$,
    Row 5: $\tilde S_n$,
    Row 6: $\tilde I_n$,
    Row 7: $\tilde M_n$,
    Row 8: $\tilde T_n$, */
	
	
	fp1 = fopen("seuil.txt","r");	
	for(k=0;k<9;k++) {fscanf(fp1," %lf %lf %lf %lf %lf\n", &seuil[k][0], &seuil[k][1], &seuil[k][2], &seuil[k][3], &seuil[k][4]);}
	fclose(fp1);
	
	
	
	x = (double *)calloc(n,sizeof(double)); 
	rangs = (int *)calloc(n+p,sizeof(int));
	NN = (double *)calloc(n+1,sizeof(double)); 
	MM = (double **)calloc(n+1,sizeof(double *)); 
	for(i=0; i<=n; i++){MM[i] = (double *)calloc(n+1,sizeof(double)); }
	NN2= (double *)calloc(n+1,sizeof(double)); 
	MM2 = (double **)calloc(n+1,sizeof(double *)); 
	for(i=0; i<=n; i++){MM2[i] = (double *)calloc(n+1,sizeof(double)); }
	
	
	
	fp2 = fopen(fichier[l], "a");
	
	fprintf(fp2, "\\begin{center}\n {\\sc Tableau $\\tilde T_n$}:Percentage of rejection at level $\\alpha=.05$ for a series of length $n=%d$, as estimated with $%ld$ replicates.\\\\", n,it);
	fprintf(fp2, "\n {\\tiny \n\n");  
	fprintf(fp2, "\\begin{tabular}{lrrrrrr} \n\\hline \\, \\\\\n");
	fprintf(fp2, "Model  & $p$ & $\\theta=0$ & $\\theta=1/32$ & $\\theta=1/16$ & $\\theta=1/8$ & $\\theta=1/4$\\\\ \n\\hline \\\\ \n");
	
	for(r=0;r<9;r++)     /* law */
	{
		printf("\n %s\n", nom_loi[r]);
		
		
		for(k=2;k<=p;k++) 
		{ 
			for(m=0;m<=8;m++)
				reject[m][k-2]= 0; 
		}
		
		for(j=0;j<it;j++)
		{  
			laws(x, n, r, param); 
			rank(x, n, rangs);
            
			for(k=n;k<n+p;k++)
				rangs[k] = rangs[k-n];
			
			
			
            /* Calling the statistical procedures */
            
            /* classical BDS */
            eps=1.0;
            bdsstat(x, n, p, eps, stat);
            for(k=2;k<=p;k++)
            {
                if (fabs(stat[k])>seuil[0][k-2]) reject[0][k-2]+=1.0;
            }
            
			
			/* Setting the BIAS CORRECTION  */
			Bias_Correction=0;
            /* tilde Sn star */
            eps=0.3;
            puiss_BDS_star(p,n,cte,eps);
            vec_BDS(n,NN,eps);
            var_bds(eps,p,var);
            bds_rank_lebaron_prod(rangs, n, p, stat,NN,cte,var);
            for(k=2;k<=p;k++)
            {
                if (fabs(stat[k])>seuil[1][k-2]) reject[1][k-2]+=1.0;
            }
			
            /* tilde In star */
            bds_rank_prod_int(rangs, n, p, stat);
            for(k=2;k<=p;k++)
            {
                if (fabs(stat[k])>seuil[2][k-2]) reject[2][k-2]+=1.0;
            }
            /* tilde Mn star */
            bds_rank_lebaron_sup_prod(rangs, n, p, stat);
            for(k=2;k<=p;k++)
            {
                if (fabs(stat[k])>seuil[3][k-2]) reject[3][k-2]+=1.0;
            }
            /* tilde Tn star */
            
            puiss(p,n,cte);
            matM(n,NN,MM);
            bds_rank(rangs, n, p, stat,MM,NN,cte);
            for(k=2;k<=p;k++)
            {
                if (fabs(stat[k])>seuil[4][k-2]) reject[4][k-2]+=1.0;
                
            }
            
			
			Bias_Correction=1;
            ///* tilde Sn  */
            eps=0.3;
            puiss_BDS(p,n,cte,eps);
            matM_BDS(n,MM,eps);
            var_bds(eps,p,var);
            bds_rank_lebaron(rangs, n, p, stat,MM,cte,var);
            for(k=2;k<=p;k++)
            {
                if (fabs(stat[k])>seuil[5][k-2]) reject[5][k-2]+=1.0;
            }
            
            ///* tilde In  */
            bds_rank_int(rangs, n, p, stat);
            for(k=2;k<=p;k++)
            {
                if (fabs(stat[k])>seuil[6][k-2]) reject[6][k-2]+=1.0;
            }
            
            ///* tilde Mn  */
            bds_rank_lebaron_sup(rangs, n, p, stat);
            for(k=2;k<=p;k++)
            {
                if (fabs(stat[k])>seuil[7][k-2]) reject[7][k-2]+=1.0;
            }
			
			
            /* tilde Tn  */
            puiss(p,n,cte);
            newmatM(n,NN,MM);
            bds_rank_2(rangs, n, p, stat,MM,NN,cte);
            for(k=2;k<=p;k++)
            {
				if (fabs(stat[k])>seuil[8][k-2]) reject[8][k-2]+=1.0;
            }
			
            if( (j % 100) == 0) printf("%d ", j/100); 
			
			
            
		}   /* end of iterations */
		
		for(k=2;k<=p;k++)
		{
			for(m=0;m<=8;m++)
				rej_cvm[m][k-2] = 100*((double)reject[m][k-2])/((double)it); 
		}
		
		
		
		for(k=2;k<=p;k++){
			fprintf(fp2, "\n %s & %d ",nom_loi[r], k);
			for(m=0;m<=8;m++) fprintf(fp2, " & %.2lf ", rej_cvm[m][k-2]);
			fprintf(fp2," \\\\ \n");
		}
		
		
		
	}   /* change of law */
	
	//      printf("\ndone just free memory\n");
	
	fprintf(fp2, "\n\\hline");          
	fprintf(fp2,"\n\\end{tabular}}");  
	fprintf(fp2, "\n\\end{center}");          
	fclose(fp2);          
	
	
	free(x); free(rangs); free(NN); free(NN2); 
	for(i=0;i<=n;i++){ free(MM[i]); free(MM2[i]);} 
	//		 free(MM1); free(MM2);
	
	
   }